
particledistortbeam
{
	program
	{
		varying float tcoord; /*distance from center*/
		varying vec4 scoord; /*screen coord*/
		varying float alph; /*alpha value/scale of effect*/
#ifdef VERTEX_SHADER
		attribute vec2 v_texcoord;
		attribute vec4 v_colour;
		
		void main(void)
		{
			scoord = ftetransform();
			tcoord = (v_texcoord.t - 0.5)*2.0;
			alph = v_colour.a;
			gl_Position = scoord;

		}
#endif
#ifdef FRAGMENT_SHADER
		uniform sampler2D s_t0; /*first sampler*/

		void main(void)
		{
			vec2 nst;
			float f;

			/*convert screen coords to texture coords*/
			nst = scoord.xy / scoord.w;
			nst = (1.0 + nst)/2.0;

			/*figure out scale of the effect*/
			f = 1 - tcoord*tcoord;
			if (f < 0) discard;
			f *= alph;

			gl_FragColor = texture2D(s_t0, nst - tcoord*f);
		}
#endif
	}

	/*glsl shaders use certain state as set in the first pass*/
	{
		map $currentrender
		blendfunc blend
	}
	/*add additional passes for additional samplers*/
}
